Populate an advanced route step transaction
curl --request POST \
--url https://api.delora.build/v1/advanced/stepTransaction \
--header 'Content-Type: application/json' \
--data '
{
"step": {
"id": "advanced-route:0",
"routeId": "advanced-route",
"type": "bridge",
"tool": "RELAY",
"action": {
"fromChainId": 8453,
"toChainId": 42161,
"fromToken": {
"address": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
"symbol": "USDC",
"decimals": 6,
"chainId": 8453
},
"toToken": {
"address": "0xaf88d065e77c8cC2239327C5EDb3A432268e5831",
"symbol": "USDC",
"decimals": 6,
"chainId": 42161
},
"fromAmount": "1000000"
},
"estimate": {
"fromAmount": "1000000",
"toAmount": "997321",
"toAmountMin": "992334",
"fees": {
"total": {
"amount": "0",
"currencySymbol": "USDC",
"currencyAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
"chainId": 8453
},
"breakdown": []
}
},
"execution": {
"applyFee": true
}
},
"context": {
"senderAddress": "0x1111111111111111111111111111111111111111",
"receiverAddress": "0x2222222222222222222222222222222222222222"
}
}
'import requests
url = "https://api.delora.build/v1/advanced/stepTransaction"
payload = {
"step": {
"id": "advanced-route:0",
"routeId": "advanced-route",
"type": "bridge",
"tool": "RELAY",
"action": {
"fromChainId": 8453,
"toChainId": 42161,
"fromToken": {
"address": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
"symbol": "USDC",
"decimals": 6,
"chainId": 8453
},
"toToken": {
"address": "0xaf88d065e77c8cC2239327C5EDb3A432268e5831",
"symbol": "USDC",
"decimals": 6,
"chainId": 42161
},
"fromAmount": "1000000"
},
"estimate": {
"fromAmount": "1000000",
"toAmount": "997321",
"toAmountMin": "992334",
"fees": {
"total": {
"amount": "0",
"currencySymbol": "USDC",
"currencyAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
"chainId": 8453
},
"breakdown": []
}
},
"execution": { "applyFee": True }
},
"context": {
"senderAddress": "0x1111111111111111111111111111111111111111",
"receiverAddress": "0x2222222222222222222222222222222222222222"
}
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
step: {
id: 'advanced-route:0',
routeId: 'advanced-route',
type: 'bridge',
tool: 'RELAY',
action: {
fromChainId: 8453,
toChainId: 42161,
fromToken: {
address: '0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913',
symbol: 'USDC',
decimals: 6,
chainId: 8453
},
toToken: {
address: '0xaf88d065e77c8cC2239327C5EDb3A432268e5831',
symbol: 'USDC',
decimals: 6,
chainId: 42161
},
fromAmount: '1000000'
},
estimate: {
fromAmount: '1000000',
toAmount: '997321',
toAmountMin: '992334',
fees: {
total: {
amount: '0',
currencySymbol: 'USDC',
currencyAddress: '0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913',
chainId: 8453
},
breakdown: []
}
},
execution: {applyFee: true}
},
context: {
senderAddress: '0x1111111111111111111111111111111111111111',
receiverAddress: '0x2222222222222222222222222222222222222222'
}
})
};
fetch('https://api.delora.build/v1/advanced/stepTransaction', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "<string>",
"routeId": "<string>",
"tool": "RELAY",
"action": {
"fromChainId": 123,
"toChainId": 123,
"fromToken": {
"address": "<string>",
"symbol": "<string>",
"decimals": 123,
"chainId": 123
},
"toToken": {
"address": "<string>",
"symbol": "<string>",
"decimals": 123,
"chainId": 123
},
"fromAmount": "<string>",
"slippage": 123,
"fromAddress": "<string>",
"toAddress": "<string>"
},
"estimate": {
"fromAmount": "<string>",
"toAmount": "<string>",
"toAmountMin": "<string>",
"fees": {
"total": {
"amount": "2679",
"currencySymbol": "USDC",
"currencyAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
"chainId": 8453,
"decimals": 6
},
"breakdown": [
{
"amount": "2679",
"currencySymbol": "USDC",
"currencyAddress": "0x833589fCD6eDb6E08f4c7C32D4f71b54bdA02913",
"chainId": 8453,
"type": "gas",
"decimals": 6,
"amountUsd": "0.01"
}
],
"totalUsd": "0.01"
},
"quoteFromAmount": "<string>",
"estimatedTimeSec": 123,
"approvalAddress": "<string>",
"simulatedToAmount": "<string>",
"simulation": {
"source": "TENDERLY",
"executionStatus": "SUCCESS",
"outputValidation": "VERIFIED",
"advertisedOutputAmount": "997321",
"latencyMs": 712,
"providerResults": [
{
"source": "TENDERLY",
"executionStatus": "SUCCESS",
"outputValidation": "VERIFIED",
"latencyMs": 312,
"simulatedOutputAmount": "996100",
"deviation": {
"absolute": "-1200",
"bps": -12,
"percent": "-0.12%"
},
"gasUsed": "142331",
"reason": "Exceeded 700ms"
}
],
"simulatedOutputAmount": "996100",
"deviation": {
"absolute": "-1200",
"bps": -12,
"percent": "-0.12%"
},
"gasUsed": "142331",
"reason": "Simulation exceeded budget"
}
},
"execution": {
"applyFee": true,
"requiresPreviousStepAmount": true,
"quoteRequest": {},
"routeRequest": {}
},
"transactionRequest": {
"to": "<string>",
"value": "<string>",
"data": "<string>",
"gas": {
"gasPrice": "0x3b9aca00",
"maxFeePerGas": "0x59682f00",
"maxPriorityFeePerGas": "0x3b9aca00"
},
"transactionSize": {
"raw": 123,
"encoded": 123
}
},
"integrator": "<string>",
"fee": 123,
"warnings": [
{
"code": "SOLANA_INSUFFICIENT_BALANCE",
"message": "Solana simulation reported insufficient balance."
}
],
"bridgeScan": {}
}{
"statusCode": 400,
"code": "VALIDATION_ERROR",
"message": "Invalid request parameters",
"timestamp": "2026-05-13T18:00:00.000Z",
"details": {
"message": [
"One or more request parameters are invalid."
]
},
"path": "/v1/..."
}{
"statusCode": 429,
"code": "RATE_LIMIT",
"message": "Rate limit exceeded. Please try again later.",
"details": {
"message": "Rate limit exceeded. Please try again later."
},
"timestamp": "2026-05-15T16:58:45.603Z",
"path": "/v1/advanced/stepTransaction"
}API Endpoints
Populate advanced step transaction
Re-quotes the selected step and returns executable transaction data. For later steps, pass the actual previous step output as context.previousStepReceivedAmount.
POST
/
v1
/
advanced
/
stepTransaction
Populate an advanced route step transaction
Use this endpoint to turn one selected advanced route step into executable transaction data.
Headers
Optional API key for higher rate limits and fee rules.
Body
application/json
Response
Populated advanced step with executable transaction data.
Available options:
swap, bridge Example:
"RELAY"
Show child attributes
Show child attributes
Estimated result for this route step. Treat it as planning data; call POST /v1/advanced/stepTransaction before execution.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Executable transaction payload returned on a populated step from POST /v1/advanced/stepTransaction.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Bridge tracking metadata returned when the selected bridge adapter provides it.
⌘I

